diff --git a/dlls/mfmediaengine/main.c b/dlls/mfmediaengine/main.c
index a191448b6..98504c5e2 100644
--- a/dlls/mfmediaengine/main.c
+++ b/dlls/mfmediaengine/main.c
@@ -1714,9 +1589,9 @@ static BOOL WINAPI media_engine_IsPaused(IMFMediaEngineEx *iface)
     return value;
 }
 
-static double WINAPI media_engine_GetDefaultPlaybackRate(IMFMediaEngineEx *iface)
+static double WINAPI media_engine_GetDefaultPlaybackRate(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     double rate;
 
     TRACE("%p.\n", iface);
@@ -1728,9 +1603,9 @@ static double WINAPI media_engine_GetDefaultPlaybackRate(IMFMediaEngineEx *iface
     return rate;
 }
 
-static HRESULT WINAPI media_engine_SetDefaultPlaybackRate(IMFMediaEngineEx *iface, double rate)
+static HRESULT WINAPI media_engine_SetDefaultPlaybackRate(IMFMediaEngine *iface, double rate)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %f.\n", iface, rate);
@@ -1748,9 +1623,9 @@ static HRESULT WINAPI media_engine_SetDefaultPlaybackRate(IMFMediaEngineEx *ifac
     return hr;
 }
 
-static double WINAPI media_engine_GetPlaybackRate(IMFMediaEngineEx *iface)
+static double WINAPI media_engine_GetPlaybackRate(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     double rate;
 
     TRACE("%p.\n", iface);
@@ -1762,9 +1637,9 @@ static double WINAPI media_engine_GetPlaybackRate(IMFMediaEngineEx *iface)
     return rate;
 }
 
-static HRESULT WINAPI media_engine_SetPlaybackRate(IMFMediaEngineEx *iface, double rate)
+static HRESULT WINAPI media_engine_SetPlaybackRate(IMFMediaEngine *iface, double rate)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %f.\n", iface, rate);
@@ -1782,43 +1657,23 @@ static HRESULT WINAPI media_engine_SetPlaybackRate(IMFMediaEngineEx *iface, doub
     return hr;
 }
 
-static HRESULT WINAPI media_engine_GetPlayed(IMFMediaEngineEx *iface, IMFMediaTimeRange **played)
+static HRESULT WINAPI media_engine_GetPlayed(IMFMediaEngine *iface, IMFMediaTimeRange **played)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = E_NOTIMPL;
-
     FIXME("(%p, %p): stub.\n", iface, played);
 
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
+    return E_NOTIMPL;
 }
 
-static HRESULT WINAPI media_engine_GetSeekable(IMFMediaEngineEx *iface, IMFMediaTimeRange **seekable)
+static HRESULT WINAPI media_engine_GetSeekable(IMFMediaEngine *iface, IMFMediaTimeRange **seekable)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = E_NOTIMPL;
-
     FIXME("(%p, %p): stub.\n", iface, seekable);
 
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
+    return E_NOTIMPL;
 }
 
-static BOOL WINAPI media_engine_IsEnded(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_IsEnded(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL value;
 
     TRACE("%p.\n", iface);
@@ -1830,9 +1685,9 @@ static BOOL WINAPI media_engine_IsEnded(IMFMediaEngineEx *iface)
     return value;
 }
 
-static BOOL WINAPI media_engine_GetAutoPlay(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_GetAutoPlay(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL value;
 
     TRACE("%p.\n", iface);
@@ -1844,9 +1699,9 @@ static BOOL WINAPI media_engine_GetAutoPlay(IMFMediaEngineEx *iface)
     return value;
 }
 
-static HRESULT WINAPI media_engine_SetAutoPlay(IMFMediaEngineEx *iface, BOOL autoplay)
+static HRESULT WINAPI media_engine_SetAutoPlay(IMFMediaEngine *iface, BOOL autoplay)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
 
     FIXME("(%p, %d): stub.\n", iface, autoplay);
 
@@ -1857,9 +1712,9 @@ static HRESULT WINAPI media_engine_SetAutoPlay(IMFMediaEngineEx *iface, BOOL aut
     return S_OK;
 }
 
-static BOOL WINAPI media_engine_GetLoop(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_GetLoop(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL value;
 
     TRACE("%p.\n", iface);
@@ -1871,9 +1726,9 @@ static BOOL WINAPI media_engine_GetLoop(IMFMediaEngineEx *iface)
     return value;
 }
 
-static HRESULT WINAPI media_engine_SetLoop(IMFMediaEngineEx *iface, BOOL loop)
+static HRESULT WINAPI media_engine_SetLoop(IMFMediaEngine *iface, BOOL loop)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
 
     FIXME("(%p, %d): stub.\n", iface, loop);
 
@@ -1884,75 +1739,63 @@ static HRESULT WINAPI media_engine_SetLoop(IMFMediaEngineEx *iface, BOOL loop)
     return S_OK;
 }
 
-static HRESULT WINAPI media_engine_Play(IMFMediaEngineEx *iface)
+static HRESULT WINAPI media_engine_Play(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = S_OK;
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
 
     TRACE("%p.\n", iface);
 
     EnterCriticalSection(&engine->cs);
 
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-    {
-        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS, 0, 0);
-
-        if (!(engine->flags & FLAGS_ENGINE_WAITING))
-        {
-            media_engine_set_flag(engine, FLAGS_ENGINE_PAUSED | FLAGS_ENGINE_IS_ENDED, FALSE);
-            IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PLAY, 0, 0);
+    IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS, 0, 0);
 
-            if (!(engine->flags & FLAGS_ENGINE_SOURCE_PENDING))
-                media_engine_start_playback(engine);
-            else
-                media_engine_set_flag(engine, FLAGS_ENGINE_PLAY_PENDING, TRUE);
+    if (!(engine->flags & FLAGS_ENGINE_WAITING))
+    {
+        media_engine_set_flag(engine, FLAGS_ENGINE_PAUSED | FLAGS_ENGINE_IS_ENDED, FALSE);
+        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PLAY, 0, 0);
 
-            media_engine_set_flag(engine, FLAGS_ENGINE_WAITING, TRUE);
-        }
+        if (!(engine->flags & FLAGS_ENGINE_SOURCE_PENDING))
+            media_engine_start_playback(engine);
+        else
+            media_engine_set_flag(engine, FLAGS_ENGINE_PLAY_PENDING, TRUE);
 
-        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_WAITING, 0, 0);
+        media_engine_set_flag(engine, FLAGS_ENGINE_WAITING, TRUE);
     }
 
+    IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_WAITING, 0, 0);
+
     LeaveCriticalSection(&engine->cs);
 
-    return hr;
+    return S_OK;
 }
 
-static HRESULT WINAPI media_engine_Pause(IMFMediaEngineEx *iface)
+static HRESULT WINAPI media_engine_Pause(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = S_OK;
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
 
     TRACE("%p.\n", iface);
 
     EnterCriticalSection(&engine->cs);
 
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
+    if (!(engine->flags & FLAGS_ENGINE_PAUSED))
     {
-        if (!(engine->flags & FLAGS_ENGINE_PAUSED))
-        {
-            media_engine_set_flag(engine, FLAGS_ENGINE_WAITING | FLAGS_ENGINE_IS_ENDED, FALSE);
-            media_engine_set_flag(engine, FLAGS_ENGINE_PAUSED, TRUE);
-
-            IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_TIMEUPDATE, 0, 0);
-            IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PAUSE, 0, 0);
-        }
+        media_engine_set_flag(engine, FLAGS_ENGINE_WAITING | FLAGS_ENGINE_IS_ENDED, FALSE);
+        media_engine_set_flag(engine, FLAGS_ENGINE_PAUSED, TRUE);
 
-        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS, 0, 0);
+        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_TIMEUPDATE, 0, 0);
+        IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PAUSE, 0, 0);
     }
 
+    IMFMediaEngineNotify_EventNotify(engine->callback, MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS, 0, 0);
+
     LeaveCriticalSection(&engine->cs);
 
-    return hr;
+    return S_OK;
 }
 
-static BOOL WINAPI media_engine_GetMuted(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_GetMuted(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL ret;
 
     TRACE("%p.\n", iface);
@@ -1964,9 +1807,9 @@ static BOOL WINAPI media_engine_GetMuted(IMFMediaEngineEx *iface)
     return ret;
 }
 
-static HRESULT WINAPI media_engine_SetMuted(IMFMediaEngineEx *iface, BOOL muted)
+static HRESULT WINAPI media_engine_SetMuted(IMFMediaEngine *iface, BOOL muted)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %d.\n", iface, muted);
@@ -1984,9 +1827,9 @@ static HRESULT WINAPI media_engine_SetMuted(IMFMediaEngineEx *iface, BOOL muted)
     return hr;
 }
 
-static double WINAPI media_engine_GetVolume(IMFMediaEngineEx *iface)
+static double WINAPI media_engine_GetVolume(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     double volume;
 
     TRACE("%p.\n", iface);
@@ -1998,9 +1841,9 @@ static double WINAPI media_engine_GetVolume(IMFMediaEngineEx *iface)
     return volume;
 }
 
-static HRESULT WINAPI media_engine_SetVolume(IMFMediaEngineEx *iface, double volume)
+static HRESULT WINAPI media_engine_SetVolume(IMFMediaEngine *iface, double volume)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %f.\n", iface, volume);
@@ -2018,9 +1861,9 @@ static HRESULT WINAPI media_engine_SetVolume(IMFMediaEngineEx *iface, double vol
     return hr;
 }
 
-static BOOL WINAPI media_engine_HasVideo(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_HasVideo(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL value;
 
     TRACE("%p.\n", iface);
@@ -2032,9 +1875,9 @@ static BOOL WINAPI media_engine_HasVideo(IMFMediaEngineEx *iface)
     return value;
 }
 
-static BOOL WINAPI media_engine_HasAudio(IMFMediaEngineEx *iface)
+static BOOL WINAPI media_engine_HasAudio(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     BOOL value;
 
     TRACE("%p.\n", iface);
@@ -2046,9 +1889,9 @@ static BOOL WINAPI media_engine_HasAudio(IMFMediaEngineEx *iface)
     return value;
 }
 
-static HRESULT WINAPI media_engine_GetNativeVideoSize(IMFMediaEngineEx *iface, DWORD *cx, DWORD *cy)
+static HRESULT WINAPI media_engine_GetNativeVideoSize(IMFMediaEngine *iface, DWORD *cx, DWORD *cy)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %p, %p.\n", iface, cx, cy);
@@ -2073,9 +1916,9 @@ static HRESULT WINAPI media_engine_GetNativeVideoSize(IMFMediaEngineEx *iface, D
     return hr;
 }
 
-static HRESULT WINAPI media_engine_GetVideoAspectRatio(IMFMediaEngineEx *iface, DWORD *cx, DWORD *cy)
+static HRESULT WINAPI media_engine_GetVideoAspectRatio(IMFMediaEngine *iface, DWORD *cx, DWORD *cy)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     TRACE("%p, %p, %p.\n", iface, cx, cy);
@@ -2100,9 +1943,9 @@ static HRESULT WINAPI media_engine_GetVideoAspectRatio(IMFMediaEngineEx *iface,
     return hr;
 }
 
-static HRESULT WINAPI media_engine_Shutdown(IMFMediaEngineEx *iface)
+static HRESULT WINAPI media_engine_Shutdown(IMFMediaEngine *iface)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr = S_OK;
 
     FIXME("(%p): stub.\n", iface);
@@ -2113,7 +1956,6 @@ static HRESULT WINAPI media_engine_Shutdown(IMFMediaEngineEx *iface)
     else
     {
         media_engine_set_flag(engine, FLAGS_ENGINE_SHUT_DOWN, TRUE);
-        media_engine_clear_presentation(engine);
         IMFMediaSession_Shutdown(engine->session);
     }
     LeaveCriticalSection(&engine->cs);
@@ -2215,7 +2057,7 @@ static HRESULT media_engine_transfer_to_d3d11_texture(struct media_engine *engin
 
     if (FAILED(hr = media_engine_create_d3d11_video_frame_resources(engine, device)))
     {
-        WARN("Failed to create d3d resources, hr %#lx.\n", hr);
+        WARN("Failed to create d3d resources, hr %#x.\n", hr);
         goto done;
     }
 
@@ -2234,7 +2076,7 @@ static HRESULT media_engine_transfer_to_d3d11_texture(struct media_engine *engin
 
     if (FAILED(hr = ID3D11Device_CreateRenderTargetView(device, (ID3D11Resource *)texture, NULL, &rtv)))
     {
-        WARN("Failed to create an rtv, hr %#lx.\n", hr);
+        WARN("Failed to create an rtv, hr %#x.\n", hr);
         goto done;
     }
 
@@ -2343,10 +2185,10 @@ static HRESULT media_engine_transfer_to_d3d11_texture(struct media_engine *engin
     return hr;
 }
 
-static HRESULT WINAPI media_engine_TransferVideoFrame(IMFMediaEngineEx *iface, IUnknown *surface,
+static HRESULT WINAPI media_engine_TransferVideoFrame(IMFMediaEngine *iface, IUnknown *surface,
         const MFVideoNormalizedRect *src_rect, const RECT *dst_rect, const MFARGB *color)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     ID3D11Texture2D *texture;
     HRESULT hr = E_NOINTERFACE;
 
@@ -2371,9 +2213,9 @@ static HRESULT WINAPI media_engine_TransferVideoFrame(IMFMediaEngineEx *iface, I
     return hr;
 }
 
-static HRESULT WINAPI media_engine_OnVideoStreamTick(IMFMediaEngineEx *iface, LONGLONG *pts)
+static HRESULT WINAPI media_engine_OnVideoStreamTick(IMFMediaEngine *iface, LONGLONG *pts)
 {
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
+    struct media_engine *engine = impl_from_IMFMediaEngine(iface);
     HRESULT hr;
 
     TRACE("%p, %p.\n", iface, pts);
@@ -2395,390 +2237,7 @@ static HRESULT WINAPI media_engine_OnVideoStreamTick(IMFMediaEngineEx *iface, LO
     return hr;
 }
 
-static HRESULT WINAPI media_engine_SetSourceFromByteStream(IMFMediaEngineEx *iface, IMFByteStream *bytestream, BSTR url)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr;
-
-    TRACE("%p, %p, %s.\n", iface, bytestream, debugstr_w(url));
-
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else if (!bytestream || !url)
-        hr = E_POINTER;
-    else
-        hr = media_engine_set_source(engine, bytestream, url);
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetStatistics(IMFMediaEngineEx *iface, MF_MEDIA_ENGINE_STATISTIC stat_id, PROPVARIANT *stat)
-{
-    FIXME("%p, %x, %p stub.\n", iface, stat_id, stat);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_UpdateVideoStream(IMFMediaEngineEx *iface, const MFVideoNormalizedRect *src,
-        const RECT *dst, const MFARGB *border_color)
-{
-    FIXME("%p, %p, %p, %p stub.\n", iface, src, dst, border_color);
-
-    return E_NOTIMPL;
-}
-
-static double WINAPI media_engine_GetBalance(IMFMediaEngineEx *iface)
-{
-    FIXME("%p stub.\n", iface);
-
-    return 0.0;
-}
-
-static HRESULT WINAPI media_engine_SetBalance(IMFMediaEngineEx *iface, double balance)
-{
-    FIXME("%p, %f stub.\n", iface, balance);
-
-    return E_NOTIMPL;
-}
-
-static BOOL WINAPI media_engine_IsPlaybackRateSupported(IMFMediaEngineEx *iface, double rate)
-{
-    FIXME("%p, %f stub.\n", iface, rate);
-
-    return FALSE;
-}
-
-static HRESULT WINAPI media_engine_FrameStep(IMFMediaEngineEx *iface, BOOL forward)
-{
-    FIXME("%p, %d stub.\n", iface, forward);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetResourceCharacteristics(IMFMediaEngineEx *iface, DWORD *flags)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = E_FAIL;
-
-    TRACE("%p, %p.\n", iface, flags);
-
-    EnterCriticalSection(&engine->cs);
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else if (engine->presentation.source)
-        hr = IMFMediaSource_GetCharacteristics(engine->presentation.source, flags);
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetPresentationAttribute(IMFMediaEngineEx *iface, REFGUID attribute,
-        PROPVARIANT *value)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = E_FAIL;
-
-    TRACE("%p, %s, %p.\n", iface, debugstr_guid(attribute), value);
-
-    EnterCriticalSection(&engine->cs);
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else if (engine->presentation.pd)
-        hr = IMFPresentationDescriptor_GetItem(engine->presentation.pd, attribute, value);
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetNumberOfStreams(IMFMediaEngineEx *iface, DWORD *stream_count)
-{
-    FIXME("%p, %p stub.\n", iface, stream_count);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetStreamAttribute(IMFMediaEngineEx *iface, DWORD stream_index, REFGUID attribute,
-        PROPVARIANT *value)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    IMFStreamDescriptor *sd;
-    HRESULT hr = E_FAIL;
-    BOOL selected;
-
-    TRACE("%p, %ld, %s, %p.\n", iface, stream_index, debugstr_guid(attribute), value);
-
-    EnterCriticalSection(&engine->cs);
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else if (engine->presentation.pd)
-    {
-        if (SUCCEEDED(hr = IMFPresentationDescriptor_GetStreamDescriptorByIndex(engine->presentation.pd,
-                stream_index, &selected, &sd)))
-        {
-            hr = IMFStreamDescriptor_GetItem(sd, attribute, value);
-            IMFStreamDescriptor_Release(sd);
-        }
-    }
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetStreamSelection(IMFMediaEngineEx *iface, DWORD stream_index, BOOL *enabled)
-{
-    FIXME("%p, %ld, %p stub.\n", iface, stream_index, enabled);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_SetStreamSelection(IMFMediaEngineEx *iface, DWORD stream_index, BOOL enabled)
-{
-    FIXME("%p, %ld, %d stub.\n", iface, stream_index, enabled);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_ApplyStreamSelections(IMFMediaEngineEx *iface)
-{
-    FIXME("%p stub.\n", iface);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_IsProtected(IMFMediaEngineEx *iface, BOOL *protected)
-{
-    FIXME("%p, %p stub.\n", iface, protected);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_InsertVideoEffect(IMFMediaEngineEx *iface, IUnknown *effect, BOOL is_optional)
-{
-    FIXME("%p, %p, %d stub.\n", iface, effect, is_optional);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_InsertAudioEffect(IMFMediaEngineEx *iface, IUnknown *effect, BOOL is_optional)
-{
-    FIXME("%p, %p, %d stub.\n", iface, effect, is_optional);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_RemoveAllEffects(IMFMediaEngineEx *iface)
-{
-    FIXME("%p stub.\n", iface);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_SetTimelineMarkerTimer(IMFMediaEngineEx *iface, double timeout)
-{
-    FIXME("%p, %f stub.\n", iface, timeout);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetTimelineMarkerTimer(IMFMediaEngineEx *iface, double *timeout)
-{
-    FIXME("%p, %p stub.\n", iface, timeout);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_CancelTimelineMarkerTimer(IMFMediaEngineEx *iface)
-{
-    FIXME("%p stub.\n", iface);
-
-    return E_NOTIMPL;
-}
-
-static BOOL WINAPI media_engine_IsStereo3D(IMFMediaEngineEx *iface)
-{
-    FIXME("%p stub.\n", iface);
-
-    return FALSE;
-}
-
-static HRESULT WINAPI media_engine_GetStereo3DFramePackingMode(IMFMediaEngineEx *iface, MF_MEDIA_ENGINE_S3D_PACKING_MODE *mode)
-{
-    FIXME("%p, %p stub.\n", iface, mode);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_SetStereo3DFramePackingMode(IMFMediaEngineEx *iface, MF_MEDIA_ENGINE_S3D_PACKING_MODE mode)
-{
-    FIXME("%p, %#x stub.\n", iface, mode);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetStereo3DRenderMode(IMFMediaEngineEx *iface, MF3DVideoOutputType *output_type)
-{
-    FIXME("%p, %p stub.\n", iface, output_type);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_SetStereo3DRenderMode(IMFMediaEngineEx *iface, MF3DVideoOutputType output_type)
-{
-    FIXME("%p, %#x stub.\n", iface, output_type);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_EnableWindowlessSwapchainMode(IMFMediaEngineEx *iface, BOOL enable)
-{
-    FIXME("%p, %d stub.\n", iface, enable);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetVideoSwapchainHandle(IMFMediaEngineEx *iface, HANDLE *swapchain)
-{
-    FIXME("%p, %p stub.\n", iface, swapchain);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_EnableHorizontalMirrorMode(IMFMediaEngineEx *iface, BOOL enable)
-{
-    FIXME("%p, %d stub.\n", iface, enable);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_GetAudioStreamCategory(IMFMediaEngineEx *iface, UINT32 *category)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr;
-
-    TRACE("%p, %p.\n", iface, category);
-
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        hr = IMFAttributes_GetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_CATEGORY, category);
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_SetAudioStreamCategory(IMFMediaEngineEx *iface, UINT32 category)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr;
-
-    TRACE("%p, %u.\n", iface, category);
-
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        hr = IMFAttributes_SetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_CATEGORY, category);
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetAudioEndpointRole(IMFMediaEngineEx *iface, UINT32 *role)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr;
-
-    TRACE("%p, %p.\n", iface, role);
-
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        hr = IMFAttributes_GetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE, role);
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_SetAudioEndpointRole(IMFMediaEngineEx *iface, UINT32 role)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr;
-
-    TRACE("%p, %u.\n", iface, role);
-
-    EnterCriticalSection(&engine->cs);
-
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        hr = IMFAttributes_SetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE, role);
-
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_GetRealTimeMode(IMFMediaEngineEx *iface, BOOL *enabled)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = S_OK;
-
-    TRACE("%p, %p.\n", iface, enabled);
-
-    EnterCriticalSection(&engine->cs);
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        *enabled = !!(engine->flags & MF_MEDIA_ENGINE_REAL_TIME_MODE);
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_SetRealTimeMode(IMFMediaEngineEx *iface, BOOL enable)
-{
-    struct media_engine *engine = impl_from_IMFMediaEngineEx(iface);
-    HRESULT hr = S_OK;
-
-    TRACE("%p, %d.\n", iface, enable);
-
-    EnterCriticalSection(&engine->cs);
-    if (engine->flags & FLAGS_ENGINE_SHUT_DOWN)
-        hr = MF_E_SHUTDOWN;
-    else
-        media_engine_set_flag(engine, MF_MEDIA_ENGINE_REAL_TIME_MODE, enable);
-    LeaveCriticalSection(&engine->cs);
-
-    return hr;
-}
-
-static HRESULT WINAPI media_engine_SetCurrentTimeEx(IMFMediaEngineEx *iface, double seektime, MF_MEDIA_ENGINE_SEEK_MODE mode)
-{
-    FIXME("%p, %f, %#x stub.\n", iface, seektime, mode);
-
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI media_engine_EnableTimeUpdateTimer(IMFMediaEngineEx *iface, BOOL enable)
-{
-    FIXME("%p, %d stub.\n", iface, enable);
-
-    return E_NOTIMPL;
-}
-
-static const IMFMediaEngineExVtbl media_engine_vtbl =
+static const IMFMediaEngineVtbl media_engine_vtbl =
 {
     media_engine_QueryInterface,
     media_engine_AddRef,
@@ -2825,77 +2284,6 @@ static const IMFMediaEngineExVtbl media_engine_vtbl =
     media_engine_Shutdown,
     media_engine_TransferVideoFrame,
     media_engine_OnVideoStreamTick,
-    media_engine_SetSourceFromByteStream,
-    media_engine_GetStatistics,
-    media_engine_UpdateVideoStream,
-    media_engine_GetBalance,
-    media_engine_SetBalance,
-    media_engine_IsPlaybackRateSupported,
-    media_engine_FrameStep,
-    media_engine_GetResourceCharacteristics,
-    media_engine_GetPresentationAttribute,
-    media_engine_GetNumberOfStreams,
-    media_engine_GetStreamAttribute,
-    media_engine_GetStreamSelection,
-    media_engine_SetStreamSelection,
-    media_engine_ApplyStreamSelections,
-    media_engine_IsProtected,
-    media_engine_InsertVideoEffect,
-    media_engine_InsertAudioEffect,
-    media_engine_RemoveAllEffects,
-    media_engine_SetTimelineMarkerTimer,
-    media_engine_GetTimelineMarkerTimer,
-    media_engine_CancelTimelineMarkerTimer,
-    media_engine_IsStereo3D,
-    media_engine_GetStereo3DFramePackingMode,
-    media_engine_SetStereo3DFramePackingMode,
-    media_engine_GetStereo3DRenderMode,
-    media_engine_SetStereo3DRenderMode,
-    media_engine_EnableWindowlessSwapchainMode,
-    media_engine_GetVideoSwapchainHandle,
-    media_engine_EnableHorizontalMirrorMode,
-    media_engine_GetAudioStreamCategory,
-    media_engine_SetAudioStreamCategory,
-    media_engine_GetAudioEndpointRole,
-    media_engine_SetAudioEndpointRole,
-    media_engine_GetRealTimeMode,
-    media_engine_SetRealTimeMode,
-    media_engine_SetCurrentTimeEx,
-    media_engine_EnableTimeUpdateTimer,
-};
-
-static HRESULT WINAPI media_engine_gs_QueryInterface(IMFGetService *iface, REFIID riid, void **obj)
-{
-    struct media_engine *engine = impl_from_IMFGetService(iface);
-    return IMFMediaEngineEx_QueryInterface(&engine->IMFMediaEngineEx_iface, riid, obj);
-}
-
-static ULONG WINAPI media_engine_gs_AddRef(IMFGetService *iface)
-{
-    struct media_engine *engine = impl_from_IMFGetService(iface);
-    return IMFMediaEngineEx_AddRef(&engine->IMFMediaEngineEx_iface);
-}
-
-static ULONG WINAPI media_engine_gs_Release(IMFGetService *iface)
-{
-    struct media_engine *engine = impl_from_IMFGetService(iface);
-    return IMFMediaEngineEx_Release(&engine->IMFMediaEngineEx_iface);
-}
-
-static HRESULT WINAPI media_engine_gs_GetService(IMFGetService *iface, REFGUID service,
-        REFIID riid, void **object)
-{
-    FIXME("%p, %s, %s, %p stub.\n", iface, debugstr_guid(service), debugstr_guid(riid), object);
-
-    return E_NOTIMPL;
-}
-
-static const IMFGetServiceVtbl media_engine_get_service_vtbl =
-{
-    media_engine_gs_QueryInterface,
-    media_engine_gs_AddRef,
-    media_engine_gs_Release,
-    media_engine_gs_GetService,
 };
 
 static HRESULT WINAPI media_engine_grabber_callback_QueryInterface(IMFSampleGrabberSinkCallback *iface,
@@ -2916,13 +2304,13 @@ static HRESULT WINAPI media_engine_grabber_callback_QueryInterface(IMFSampleGrab
 static ULONG WINAPI media_engine_grabber_callback_AddRef(IMFSampleGrabberSinkCallback *iface)
 {
     struct media_engine *engine = impl_from_IMFSampleGrabberSinkCallback(iface);
-    return IMFMediaEngineEx_AddRef(&engine->IMFMediaEngineEx_iface);
+    return IMFMediaEngine_AddRef(&engine->IMFMediaEngine_iface);
 }
 
 static ULONG WINAPI media_engine_grabber_callback_Release(IMFSampleGrabberSinkCallback *iface)
 {
     struct media_engine *engine = impl_from_IMFSampleGrabberSinkCallback(iface);
-    return IMFMediaEngineEx_Release(&engine->IMFMediaEngineEx_iface);
+    return IMFMediaEngine_Release(&engine->IMFMediaEngine_iface);
 }
 
 static HRESULT WINAPI media_engine_grabber_callback_OnClockStart(IMFSampleGrabberSinkCallback *iface,
@@ -3051,8 +2439,7 @@ static HRESULT init_media_engine(DWORD flags, IMFAttributes *attributes, struct
     IMFClock *clock;
     HRESULT hr;
 
-    engine->IMFMediaEngineEx_iface.lpVtbl = &media_engine_vtbl;
-    engine->IMFGetService_iface.lpVtbl = &media_engine_get_service_vtbl;
+    engine->IMFMediaEngine_iface.lpVtbl = &media_engine_vtbl;
     engine->session_events.lpVtbl = &media_engine_session_events_vtbl;
     engine->load_handler.lpVtbl = &media_engine_load_handler_vtbl;
     engine->grabber_callback.lpVtbl = &media_engine_grabber_callback_vtbl;
@@ -3096,12 +2483,6 @@ static HRESULT init_media_engine(DWORD flags, IMFAttributes *attributes, struct
     if (FAILED(hr = IMFAttributes_CopyAllItems(attributes, engine->attributes)))
         return hr;
 
-    /* Set default audio configuration */
-    if (FAILED(IMFAttributes_GetItem(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_CATEGORY, NULL)))
-        IMFAttributes_SetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_CATEGORY, AudioCategory_Other);
-    if (FAILED(IMFAttributes_GetItem(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE, NULL)))
-        IMFAttributes_SetUINT32(engine->attributes, &MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE, eMultimedia);
-
     IMFAttributes_GetUINT64(attributes, &MF_MEDIA_ENGINE_PLAYBACK_HWND, &playback_hwnd);
     hr = IMFAttributes_GetUINT32(attributes, &MF_MEDIA_ENGINE_VIDEO_OUTPUT_FORMAT, &output_format);
     if (playback_hwnd) /* FIXME: handle MF_MEDIA_ENGINE_PLAYBACK_VISUAL */
